/********************************************************************************
 *   dci710notify -- lock samsung's baloons on samsung sgh-i710 device.         *
 *                                                                              * 
 *   Copyright (C) 2004-2007 dci (dev@cpp.in)                                   *
 *                                                                              *
 *   This program is free software; you can redistribute it and/or              *
 *   modify it under the terms of the GNU General Public License version 2      *
 *   as published by the Free Software Foundation.                              *
 *                                                                              *
 *   This program is distributed in the hope that it will be useful,            *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          *
 *   General Public License version 2 for more details.                         *
 *                                                                              *
 *   You should have received a copy of the GNU General Public License          *
 *   version 2 along with this library; if not, write to the Free Software      *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
 ********************************************************************************
 */


#include <windows.h>

/* platformbuilder includes. yes, you need pb to build this. */
#include <pkfuncs.h>
#include <psyscall.h>
#include <kernel.h>

extern "C" {
	HLOCAL RemoteHeapAlloc(HPROCESS, HANDLE, DWORD, DWORD);
	VOID RemoteHeapFree(HPROCESS, HANDLE, HLOCAL);
}

#define SHELL_SHNotificationAdd     0x0037
#define SHELL_SHNotificationUpdate  0x0038
#define SHELL_SHNotificationRemove  0x0039
#define SHELL_SHNotificationGetData 0x003A

DWORD dwNotification_hook[] = \
{
				/* main: */
	0xE92D4003,	/* STMFD   SP!, {R0-R1,LR} */
	0xE59F0068, /* LDR     R0, [PC, pthdCurrent - $ - 8] ;load pointer to pointer to curthread */
	0xE5900000, /* LDR     R0, [R0] ;load pointer to curthread */
	0xE5900010, /* LDR     R0, [R0, 0x10] ;Thread->pOwnerProc */
	0xE5900020, /* LDR     R0, [R0, 0x20] ;Proc->lpszProcName */
	0xE28F105C, /* ADD     R1, PC, szBaloonExe - $ - 8 */
	0xEB000004, /* BL      wcscasecmp */
	0xE3500000, /* CMP     R0, 0 ; equeal? */
	0xE8BD4003, /* LDMFD   SP!, {R0-R1,LR} */
	0x159FF06C, /* LDRNE   PC, [PC, origHandler - $ - 8] */
	0xE59F006C, /* LDR     R0, [PC, hitResult - $ - 8] */
	0xE1A0F00E, /* MOV     PC, LR */
				/* */
				/* wcscasecmp: */
	0xE92D400E, /* STMFD   SP!, {R1-R3,LR} */
	0xE1A02000, /* MOV     R2, R0 */
				/* wccloop: */
	0xE0D200B2, /* LDRH    R0, [R2], 2 */
	0xEB000007, /* BL      chrlwr */
	0xE1A03000, /* MOV     R3, R0 ;save */
	0xE0D100B2, /* LDRH    R0, [R1], 2 */
	0xEB000004, /* BL      chrlwr */
	0xE0530000, /* SUBS    R0, R3, R0 */
	0x1A000001, /* BNE     wccexit */
	0xE3530000, /* CMP     R3, 0 */
	0x1AFFFFF6, /* BNE     wccloop */
				/* wccexit: */
	0xE8BD800E, /* LDMFD   SP!, {R1-R3,PC} */
				/* */
				/* chrlwr: */
	0xE3500041, /* CMP     R0, 0x41 */
	0xBA000001, /* BLT     clexit */
	0xE350005A, /* CMP     R0, 0x5A */
	0xD2800020, /* ADDLE   R0, R0, 0x20 */
				/* clexit: */
	0xE1A0F00E, /* MOV     PC, LR */
				/* */
	0xFFFFC894, /* pthdCurrent dw 0xFFFFC894 */
	0x006C0041, /* szBaloonExe du 'Al */
	0x00720065, /* er */
	0x00420074, /* tB */
	0x00620075, /* ub */
	0x006C0062, /* bl */
	0x002E0065, /* e. */
	0x00780065, /* ex */
	0x00000065, /* e', 0 */
				/* align 4 */
	0x00000000, /* origHandler dw 0x0 */
	0x00000000  /* hitResult   dw 0x0 */
};

int WinMain ( HINSTANCE hInst, HINSTANCE hPrevInst, LPWSTR lpCmdLine, int nCmdShow )
{
	SetKMode ( 1 );
	SetProcPermissions ( 0xFFFFFFFF );
	/* get shell cinfo */
	CINFO * ciShell = ( ( CINFO ** ) KData.aInfo[KINX_APISETS] )[SH_SHELL];
	/* clone it */
	CINFO * ciNew = NULL;
	for ( int cpool = 0; cpool < NUMARENAS; ++cpool )
	{
		heapptr_t * thptr = ( ( heapptr_t * ) KData.aInfo [ KINX_KHEAP ] ) + cpool;
		if ( ( thptr->size >= sizeof ( CINFO ) ) && ( thptr->cUsed < thptr->cMax ) )
		{
			if ( ciNew = ( CINFO * ) InterlockedPopList ( &thptr->fptr ) )
			{
				InterlockedIncrement ( &thptr->cUsed );
				break;
			}
		}
	}
	memcpy ( ciNew, ciShell, sizeof ( CINFO ) );
	//
	ciNew->ppfnMethods = ( PFNVOID * ) RemoteHeapAlloc ( ciShell->pServer->hProc, 0, LMEM_FIXED, ciShell->cMethods * sizeof ( * ciShell->ppfnMethods ) );
	ciNew->ppfnMethods = ( PFNVOID * ) MapPtrProc ( ciNew->ppfnMethods, ciShell->pServer );
	memcpy ( ( void * ) ciNew->ppfnMethods, MapPtrProc ( ciShell->ppfnMethods, ciShell->pServer ), ciShell->cMethods * sizeof ( * ciShell->ppfnMethods ) );
	/* create hooks */
	DWORD * pdwAddHook, * pdwRemHook;
	pdwAddHook = ( DWORD * ) RemoteHeapAlloc ( ciShell->pServer->hProc, 0, LMEM_FIXED, sizeof ( dwNotification_hook ) );
	pdwRemHook = ( DWORD * ) RemoteHeapAlloc ( ciShell->pServer->hProc, 0, LMEM_FIXED, sizeof ( dwNotification_hook ) );
	pdwAddHook = ( DWORD * ) MapPtrProc ( pdwAddHook, ciShell->pServer );
	pdwRemHook = ( DWORD * ) MapPtrProc ( pdwRemHook, ciShell->pServer );
	memcpy ( pdwAddHook, dwNotification_hook, sizeof ( dwNotification_hook ) );
	memcpy ( pdwRemHook, dwNotification_hook, sizeof ( dwNotification_hook ) );
	pdwAddHook [ ( sizeof ( dwNotification_hook ) / sizeof ( * dwNotification_hook ) ) - 2 ] = ( DWORD ) ciNew->ppfnMethods [ SHELL_SHNotificationAdd ];
	pdwRemHook [ ( sizeof ( dwNotification_hook ) / sizeof ( * dwNotification_hook ) ) - 2 ] = ( DWORD ) ciNew->ppfnMethods [ SHELL_SHNotificationRemove ];
	pdwAddHook [ ( sizeof ( dwNotification_hook ) / sizeof ( * dwNotification_hook ) ) - 1 ] = E_FAIL;
	pdwRemHook [ ( sizeof ( dwNotification_hook ) / sizeof ( * dwNotification_hook ) ) - 1 ] = E_FAIL;
	/* apply hooks to new cinfo */
	( ( DWORD ** ) ciNew->ppfnMethods ) [ SHELL_SHNotificationAdd ] = pdwAddHook;
	( ( DWORD ** ) ciNew->ppfnMethods ) [ SHELL_SHNotificationRemove ] = pdwRemHook;
	/* set new cinfo systemwide */
	( ( CINFO ** ) KData.aInfo[KINX_APISETS] )[SH_SHELL] = ciNew;
}




/* replace with this... sometime */
#if 0
DWORD dwCreateProcessW_hook[] = \
{				/* main: */
	0xE92D400F, /* STMFD	SP!, {R0-R3,LR} */
	0xE3500000, /* CMP	R0, 0 */
	0x0A00000C, /* BEQ	morig ;no procname, go orig */
	0xE1A03000, /* MOV	R3, R0 ;set cmpptr to procname */
				/* mloop: */
	0xE1A00003, /* MOV	R0, R3 */
	0xE28F1070, /* ADD	R1, PC, szBaloonExe - $ - 8 */
	0xE5902000, /* LDR	R2, [R0] */
	0xE3520000, /* CMP	R2, 0 */
	0x0A000006, /* BEQ	morig ;end char on cmpptr, go orig */
	0xEB000007, /* BL	wcscasecmp */
	0xE3500000, /* CMP	R0, 0 ; equeal? */
	0x12833002, /* ADDNE	R3, R3, 2 ; move ptr */
	0x1AFFFFF6, /* BNE	mloop ; again */
	0xE8BD400F, /* LDMFD	SP!, {R0-R3,LR} */
	0xE3A00000, /* MOV	R0, 0; error */
	0xE12FFF1E, /* BX	LR; go back */
				/* morig: */
	0xE8BD400F, /* LDMFD	SP!, {R0-R3,LR} */
	0xE59FF060, /* LDR	PC, [PC, origCreateProcessW - $ - 8] */
				/* */
				/* wcscasecmp: */
	0xE92D400E, /* STMFD	SP!, {R1-R3,LR} */
	0xE1A02000, /* MOV	R2, R0 */
				/* wccloop: */
	0xE0D200B2, /* LDRH	R0, [R2], 2 */
	0xEB000007, /* BL	chrlwr */
	0xE1A03000, /* MOV	R3, R0 ;save */
	0xE0D100B2, /* LDRH	R0, [R1], 2 */
	0xEB000004, /* BL	chrlwr */
	0xE0530000, /* SUBS	R0, R3, R0 */
	0x1A000001, /* BNE	wccexit */
	0xE3530000, /* CMP	R3, 0 */
	0x1AFFFFF6, /* BNE	wccloop */
				/* wccexit: */
	0xE8BD800E, /* LDMFD	SP!, {R1-R3,PC} */
				/* */
				/* chrlwr: */
	0xE3500041, /* CMP	R0, 0x41 */
	0xBA000001, /* BLT	clexit */
	0xE350005A, /* CMP	R0, 0x5A */
	0xD2800020, /* ADDLE	R0, R0, 0x20 */
				/* clexit: */
	0xE1A0F00E, /* MOV	PC, LR */
				/* align 4 */
	0x006C0041, /* szBaloonExe du 'Al */
	0x00720065, /* er */
	0x00420074, /* tB */
	0x00620075, /* ub */
	0x006C0062, /* bl */
	0x002E0065, /* e. */
	0x00780065, /* ex */
	0x00000065, /* e', 0 */
				/* align 4 */
	0x00000000  /* origCreateProcessW dw 0 */
};
#endif
